/******************************************************************************************
 * Auswertung der Funkdaten
 * Protokoll:
 * Byte 0: Anzahl der insgesamt verschickten Bytes
 * Byte 1: Datentyp: 'A'-'Z', bzw. '1'-'5' bei Listen
 * Danach werden in Paketen zu je 10 Bytes die Variablen bzw. Elemente der Liste verschickt
 *****************************************************************************************/
void rfm_complete(void)
{
	uint16_t pointer=0;
	if(rfm_buffer[1]<55)//Überprüfung ob Liste gesendet wurde
	{
		rfm_buffer[1]-=49;
		pointer=(rfm_buffer[1])*250;
		list_length[rfm_buffer[1]]=rfm_vars;
		if(rfm_buffer[1]<3)
			data[1501] |= (1<<rfm_buffer[1]);
		else
			data[1502] |= (16<<(rfm_buffer[1]-3));
	}
	else if(rfm_buffer[1]>64)//Überprüfung ob Variable gesendet wurde
	{
		rfm_buffer[1]-=65;
		pointer=1250+(rfm_buffer[1])*10;
		uint8_t packet = (rfm_buffer[1]+2)/3;
		uint8_t byte = packet/2;
		uint8_t shift = (rfm_buffer[1]+2)-packet*3;
		if(packet-2*byte==0)
			data[1502+byte] |= (16<<shift);
		else
			data[1502+byte] |= (1<<shift);
	}
	uint8_t i;
	for(i=0;i<rfm_vars*10;i++)
	{
		//Daten vom rfm_buffer in den Speicher für Taschenrechnerdaten übertragen
		data[pointer+i]=rfm_buffer[i+2];
	}
}
//Funktion wird immer aufgerufen, wenn ein Byte über Funk empfangen wurde.
void rfm_data(void)
{
	//ankommendes Bytes speichern
	rfm_buffer[rfm_count] = RFM12B_spi(0xB000) & 0x00FF;
	//das erste Byte enthält die Anzahl der insgesamt gesendeten Bytes. Diese wird gespeichert.
	if(rfm_count==0)
		rfm_receive = rfm_buffer[0];
	if(rfm_count==rfm_receive-1)//überprüft, ob alle Bytes angekommen sind.
	{
		//berechnet die Anzahl der versendeten Variablen (pro Variabl 10 Bytes)
		rfm_vars=(rfm_receive-2)/10;
		rfm_count = 0;
		//Empfänger zurüchsetzen
		RFM12B_spi(0xCA81);
		RFM12B_spi(0xCA83);
		//empfangene Daten auswerten
		rfm_complete();
	}
	else
		rfm_count++;
}

