#define Clear_Checksum() checksum=0
//empfängt X Bytes und verwirft sie
void ignore_uart(uint8_t ans)
{
	for(;ans>0;ans--)uart_getc();
}
//sendet X-mal 0xff (unbenutzte Bytes)
void send_fill(uint8_t ans)
{
	for(;ans>0;ans--)uart_putc(0xff);
}
//sendet die Checksumme
void send_checksum(void)
{
	checksum = 256-checksum;
	uart_putc(checksum);
	Clear_Checksum();
}
//holt eine Variable im Taschenrechnerformat (10 Bytes)
//pointer: Speicherstelle der Variable
void get_var(uint16_t pointer)
{
	ignore_uart(5);
	uint8_t i;
	for(i=0;i<10;i++)
	{
		data[pointer+i]=uart_getc();
	}
	uart_getc();
	long_delay(1);
	wdt_reset();
	uart_putc(0x06);
}
//sendet eine Variable im Taschenrechnerformat (10 Bytes)
//pointer: Speicherstelle der Variable; row: Elementnummer bei Listen
void send_var(uint16_t pointer, uint8_t row)
{
	uart_putc(0x3A);
	Clear_Checksum();
	uart_putc(0);
	uart_putc(row+1);
	uart_putc(0);
	uart_putc(1);
	uint8_t i;
	for(i=0;i<10;i++)
	{
		uart_putc(data[pointer+i]);
	}
	send_checksum();
	uart_getc();
}
//antwortet auf eine Anfrage des Taschenrechners
void gtr(void)
{
	long_delay(1);
	wdt_reset();
	uart_putc(0x13);//Bestätigung senden
	uart_getc();//1;
	uint8_t sendrec1 = uart_getc();//2;beim senden = 'V', beim empfangen = 'R'
	uint8_t sendrec2 = uart_getc();//3;beim senden = 'V', beim empfangen = 'R'
	ignore_uart(2);//4;5;
	uint8_t data_type = uart_getc();//6;Variable = 'V', Liste = 'L'
	ignore_uart(2);//7;8;
	uint8_t rows = uart_getc();//9;Anzahl der Elemente der Liste
	uart_getc();//10
	uart_getc();//11
	uint8_t var = uart_getc();//12;Variablenname (A-Z)
	ignore_uart(4);//13;14;15;16;
	uint8_t list = uart_getc()-49;//17;Listennummer ('1'-'6'), durch Subtraktion von 49 werden die ASCII-Zahlen in ihren Zahlenwert umgewandelt('1'->1)
	ignore_uart(33);//18;...50;
	long_delay(1);
	wdt_reset();
	uart_putc(0x06);
	if(sendrec1=='V' && rows<26)//wenn der Taschenrechner sendet
	{
		uint16_t pointer=0;
		uint8_t data_length=0;
		//Pointer auf die richtige Stelle setzen
		if(data_type=='V')
		{
			pointer = 1250+(var-65)*10;
			data_length=1;
		}
		else if(data_type=='L')
		{
			pointer = list*250;
			list_length[list]=data_length=rows;
		}
		uint8_t i;
		//Variablen empfangen
		for(i=0;i<rows;i++)
		{
			get_var(pointer);
			pointer+=10;
		}
		rfm_buffer[0]=data_length*10+2;//rfm12-Sendebuffer füllen
		if(data_type=='V')
			rfm_buffer[1]=var;
		else if(data_type=='L')
			rfm_buffer[1]=list+49;
		pointer-=data_length*10;
		for(i=0;i<data_length*10;i++)
		{
			rfm_buffer[i+2]=data[pointer];
			pointer++;
		}
		while(TCNT2<100);//warten bis 50ms lang kein Funkverkehr vorhanden
		cli();
		RFM12B_transmit(rfm_buffer, rfm_buffer[0]+2);
		TIFR |= (1<<TOV0);
		sei();
	}
	else if(sendrec1=='R' || sendrec2=='R')//wenn der Taschenrechner empfangen möchte
	{
		//Header zusammenstellen
		uart_getc();
		long_delay(1);
		wdt_reset();
		uart_putc(0x3A);
		Clear_Checksum();
		uart_puts("VAL");
		uart_putc(0);
		if(data_type=='L')
		{
			uart_putc('L');
			uart_putc('T');
		}
		else if(data_type=='V')
		{
			uart_putc('V');
			uart_putc('M');
		}
		uart_putc(0);
		if(data_type=='L')
			uart_putc(list_length[list]);
		else if(data_type=='V')
			uart_putc(1);
		uart_putc(0);
		uart_putc(1);
		if(data_type=='L')
		{
			uart_puts("List ");
			uart_putc(list+49);
			send_fill(10);
		}
		else if(data_type=='V')
		{
			uart_putc(var);
			send_fill(15);
		}
		uart_putc('R');
		uart_putc(0x0A);
		send_fill(20);
		send_checksum();
		uart_getc();
		uint16_t pointer=0;
		uint8_t data_length=0;
		if(data_type=='V')
		{
			pointer = 1250+(var-65)*10;
			data_length=1;
			uint8_t packet = (var-63)/3;
			uint8_t byte = packet/2;
			uint8_t shift = (var-63)-packet*3;
			if(packet-2*byte==0)
				data[1502+byte] &= ~(16<<shift);
			else
				data[1502+byte] &= ~(1<<shift);
		}
		else if(data_type=='L')
		{
			pointer = list*250;
			data_length=list_length[list];
			if(list<3)
				data[1501] &= ~(1<<list);
			else
				data[1502] &= ~(16<<(list-3));
		}
		uint8_t i;
		for(i=0;i<data_length;i++)
		{
			long_delay(1);
			wdt_reset();
			send_var(pointer, i);
			pointer+=10;
		}
		long_delay(1);
		wdt_reset();
		uart_putc(0x3A);
		Clear_Checksum();
		uart_puts("END");
		send_fill(45);
		send_checksum();
	}
}


