#include "rf12.hpp"
//prüft ob neue Daten angekommen sind
uint8_t RFM12B_ffit(void)
{
	uint8_t recv;
	RFM12B_SS_LOW();
	RFM12B_MOSI_LOW();
	recv = RFM12B_MISO_HIGH();
	RFM12B_SS_HIGH();
	return recv;
}
//Software-SPI
uint16_t RFM12B_spi(uint16_t cmd)
{
	uint8_t i;
	uint16_t recv = 0;
	RFM12B_SCK_LOW();
	RFM12B_SS_LOW();
	//16 Bits werden gelesen
	for(i=0; i<16; i++)
	{
		if(cmd & 0x8000)
			RFM12B_MOSI_HIGH();
		else
			RFM12B_MOSI_LOW();
		RFM12B_SCK_HIGH();
		recv<<=1;
		if(RFM12B_MISO_HIGH())
		{
			recv|=0x0001;
		}
		RFM12B_SCK_LOW();
		cmd<<=1;
	}
	RFM12B_SS_HIGH();
	return recv;
}

//initialisiert die Pins am Mega32
void RFM12B_init_hard()
{
	RFM12B_SS_HIGH();
	RFM12B_MOSI_HIGH();
	RFM12B_SCK_LOW();
	RFM12B_SCK_INIT();
	RFM12B_MOSI_INIT();
	RFM12B_MISO_INIT();
	RFM12B_SS_INIT();
}
//initialisiert das RFM12
void RFM12B_init_soft()
{
	RFM12B_spi(0x80E7);//EL,EF,868band,12.0pF
	RFM12B_spi(0x8238);//!er,!ebb,ET,ES,EX,!eb,!ew,DC
	RFM12B_spi(0xA74E);//869,35 MHz
	RFM12B_spi(0xC623);//9.6kbps
	RFM12B_spi(0b1001010010100001);//VDI,FAST,134kHz,0dBm,-97dBm
	RFM12B_spi(0xC2AC);//AL,!ml,DIG,DQD4
	RFM12B_spi(0xCA81);//FIFO8,SYNC,!ff,DR
	RFM12B_spi(0xCED4);//SYNC=2DD4;
	RFM12B_spi(0xC483);//@PWR,NO RSTRIC,!st,!fi,OE,EN
	RFM12B_spi(0x9850);//!mp,90kHz,MAX OUT*/
	RFM12B_spi(0xCC77);//OB1,OB0, LPX,!ddy,DDIT,BW0
	RFM12B_spi(0xE000);//NOT USE
	RFM12B_spi(0xC800);//NOT USE
	RFM12B_spi(0xC060);//2MHz,2.2V
	RFM12B_spi(0x82C8);//enable RX
	RFM12B_spi(0xCA81);
	RFM12B_spi(0xCA83);
}

//sendet ein Byte
void RFM12B_put(uint8_t data)
{
	RFM12B_WAIT_RGIT();
	RFM12B_spi(0xB800 + data);
}



//versendet eine bestimmte Anzahl Bytes über Funk
void RFM12B_transmit(uint8_t data[], uint8_t length)
{
	uint8_t i;
	//Empfänger deaktivieren
	RFM12B_spi(0x8208);
	//Sender aktivieren
	RFM12B_spi(0x8238);
	//Präambel senden
	RFM12B_put(0xAA);
	RFM12B_put(0xAA);
	RFM12B_put(0xAA);
	RFM12B_put(0x2D);
	RFM12B_put(0xD4);
	//Daten werden verschickt
	for(i = 0; i < length; i++)
	{
		RFM12B_put(data[i]);
	}
	RFM12B_WAIT_RGIT();
	//Sender deaktivieren
	RFM12B_spi(0x8208);
	//Empfänger aktivieren
	RFM12B_spi(0x82C8);
	//Empfänger zurücksetzen
	RFM12B_spi(0xCA81);
	RFM12B_spi(0xCA83);
}

