#define RFM12B_SCK_I PINC
#define RFM12B_SCK_O PORTC
#define RFM12B_SCK_P 1
#define RFM12B_SCK_D DDRC

#define RFM12B_SCK_INIT() RFM12B_SCK_D |= (1<<(RFM12B_SCK_P))
#define RFM12B_SCK_LOW() RFM12B_SCK_O &= ~(1<<(RFM12B_SCK_P))
#define RFM12B_SCK_HIGH() RFM12B_SCK_O |= (1<<(RFM12B_SCK_P))

#define RFM12B_MISO_I PIND
#define RFM12B_MISO_O PORTD
#define RFM12B_MISO_P 2
#define RFM12B_MISO_D DDRD

#define RFM12B_MISO_INIT() RFM12B_MISO_D &= ~(1<<(RFM12B_MISO_P))
#define RFM12B_MISO_LOW() ~(RFM12B_MISO_HIGH())
#define RFM12B_MISO_HIGH() RFM12B_MISO_I & (1<<(RFM12B_MISO_P))

#define RFM12B_MOSI_I PINC
#define RFM12B_MOSI_O PORTC
#define RFM12B_MOSI_P 0
#define RFM12B_MOSI_D DDRC

#define RFM12B_MOSI_INIT() RFM12B_MOSI_D |= (1<<(RFM12B_MOSI_P))
#define RFM12B_MOSI_LOW() RFM12B_MOSI_O &= ~(1<<(RFM12B_MOSI_P))
#define RFM12B_MOSI_HIGH() RFM12B_MOSI_O |= (1<<(RFM12B_MOSI_P))

#define RFM12B_SS_I PINC
#define RFM12B_SS_O PORTC
#define RFM12B_SS_P 2
#define RFM12B_SS_D DDRC

#define RFM12B_SS_INIT() RFM12B_SS_D |= (1<<(RFM12B_SS_P))
#define RFM12B_SS_LOW() RFM12B_SS_O &= ~(1<<(RFM12B_SS_P))
#define RFM12B_SS_HIGH() RFM12B_SS_O |= (1<<(RFM12B_SS_P))




uint16_t RFM12B_spi(uint16_t);
void RFM12B_init_hard();
void RFM12B_init_soft();
void RFM12B_put(uint8_t);
void RFM12B_transmit(uint8_t data[], uint8_t length);

#define RFM12B_WAIT_RGIT() while(!RFM12B_ffit()) { }

